Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters.cpp	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters.cpp	(revision 69)
@@ -21,5 +21,8 @@
 #define FUNCTION "Reservation_station::Parameters"
   Parameters::Parameters (uint32_t size_queue         ,
+			  uint32_t nb_inst_retire     ,
 			  uint32_t nb_context         ,
+			  uint32_t nb_front_end       ,
+			  uint32_t nb_ooo_engine      ,
 			  uint32_t nb_packet          ,
 			  uint32_t size_general_data  ,
@@ -34,5 +37,8 @@
 			  uint32_t nb_bypass_memory   ):
     _size_queue            (size_queue           ),
+    _nb_inst_retire        (nb_inst_retire       ),
     _nb_context            (nb_context           ),
+    _nb_front_end          (nb_front_end         ),
+    _nb_ooo_engine         (nb_ooo_engine        ),
     _nb_packet             (nb_packet            ),
     _size_general_data     (size_general_data    ),
@@ -48,9 +54,16 @@
 
     _size_context_id       (static_cast<uint32_t>(log2(_nb_context         ))),
-    _size_packet_id        (static_cast<uint32_t>(log2(_nb_packet          ))),
+    _size_front_end_id     (static_cast<uint32_t>(log2(_nb_front_end       ))),
+    _size_ooo_engine_id    (static_cast<uint32_t>(log2(_nb_ooo_engine      ))),
+    _size_rob_id           (static_cast<uint32_t>(log2(_nb_packet          ))),
     _size_general_register (static_cast<uint32_t>(log2(_nb_general_register))),
     _size_special_register (static_cast<uint32_t>(log2(_nb_special_register))),
     _size_operation        (static_cast<uint32_t>(log2(_nb_operation       ))),
-    _size_type             (static_cast<uint32_t>(log2(_nb_type            )))
+    _size_type             (static_cast<uint32_t>(log2(_nb_type            ))),
+
+    _have_port_context_id    (_size_context_id    > 0),
+    _have_port_front_end_id  (_size_front_end_id  > 0),
+    _have_port_ooo_engine_id (_size_ooo_engine_id > 0),
+    _have_port_rob_id        (_size_rob_id        > 0)
   {
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
@@ -63,5 +76,8 @@
   Parameters::Parameters (Parameters & param):
     _size_queue            (param._size_queue            ),
+    _nb_inst_retire        (param._nb_inst_retire        ),
     _nb_context            (param._nb_context            ),
+    _nb_front_end          (param._nb_front_end          ),
+    _nb_ooo_engine         (param._nb_ooo_engine         ),
     _nb_packet             (param._nb_packet             ),
     _size_general_data     (param._size_general_data     ),
@@ -77,9 +93,16 @@
 
     _size_context_id       (param._size_context_id       ),
-    _size_packet_id        (param._size_packet_id        ),
+    _size_front_end_id     (param._size_front_end_id     ),
+    _size_ooo_engine_id    (param._size_ooo_engine_id    ),
+    _size_rob_id           (param._size_rob_id           ),
     _size_general_register (param._size_general_register ),
     _size_special_register (param._size_special_register ),
     _size_operation        (param._size_operation        ),
-    _size_type             (param._size_type             )
+    _size_type             (param._size_type             ),
+
+    _have_port_context_id    (param._have_port_context_id   ),
+    _have_port_front_end_id  (param._have_port_front_end_id ),
+    _have_port_ooo_engine_id (param._have_port_ooo_engine_id),
+    _have_port_rob_id        (param._have_port_rob_id       )
   {
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_msg_error.cpp	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_msg_error.cpp	(revision 69)
@@ -7,5 +7,4 @@
 
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h"
-#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Types.h"
 #include <sstream>
 using namespace std;
@@ -29,10 +28,15 @@
     string msg = "";
 
-    if (_size_queue < 2)
+//     if (_size_queue < 2)
+//       {
+//         msg += "  - The reservation_station must be have less a depth of 2";
+//         msg += "    * size_queue                      : " + toString(_size_queue)    + "\n";
+//       }
+
+    if (_size_queue < _nb_inst_retire)
       {
-        msg += "  - The reservation_station must be have less a depth of 2";
-        msg += "    * size_queue                      : " + toString(_size_queue)    + "\n";
+        msg += "  - The reservation_station can't have more retire port than entry in the queue.";
       }
-
+    
     return msg;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_print.cpp	(revision 56)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_print.cpp	(revision 69)
@@ -30,5 +30,8 @@
     xml.balise_open("reservation_station");
     xml.singleton_begin("size_queue         "); xml.attribut("value",toString(_size_queue         )); xml.singleton_end();
+    xml.singleton_begin("nb_inst_retire     "); xml.attribut("value",toString(_nb_inst_retire     )); xml.singleton_end();
     xml.singleton_begin("nb_context         "); xml.attribut("value",toString(_nb_context         )); xml.singleton_end();
+    xml.singleton_begin("nb_front_end       "); xml.attribut("value",toString(_nb_front_end       )); xml.singleton_end();
+    xml.singleton_begin("nb_ooo_engine      "); xml.attribut("value",toString(_nb_ooo_engine      )); xml.singleton_end();
     xml.singleton_begin("nb_packet          "); xml.attribut("value",toString(_nb_packet          )); xml.singleton_end();
     xml.singleton_begin("size_general_data  "); xml.attribut("value",toString(_size_general_data  )); xml.singleton_end();
@@ -38,5 +41,5 @@
     xml.singleton_begin("nb_operation       "); xml.attribut("value",toString(_nb_operation       )); xml.singleton_end();
     xml.singleton_begin("nb_type            "); xml.attribut("value",toString(_nb_type            )); xml.singleton_end();
-    xml.singleton_begin("nb_gpr_write       "); xml.attribut("value",toString(_nb_gpr_write       )); xml.singleton_end();    
+    xml.singleton_begin("nb_gpr_write       "); xml.attribut("value",toString(_nb_gpr_write       )); xml.singleton_end();
     xml.singleton_begin("nb_spr_write       "); xml.attribut("value",toString(_nb_spr_write       )); xml.singleton_end();
     xml.singleton_begin("nb_bypass_write    "); xml.attribut("value",toString(_nb_bypass_write    )); xml.singleton_end();
